// MainDlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

class CMainDlg : public CDialogImpl<CMainDlg>, public CUpdateUI<CMainDlg>,
		public CMessageFilter, public CIdleHandler
{
	MyLib::EditNoSelectAll edit01;
	SetNoCase ahci_raid_hwids;
	std::wstring edit_text;

public:
	enum { IDD = IDD_MAINDLG };

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnIdle();

	BEGIN_UPDATE_UI_MAP(CMainDlg)
	END_UPDATE_UI_MAP()

	BEGIN_MSG_MAP_EX(CMainDlg)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
		COMMAND_ID_HANDLER_EX(IDC_BTN_INF, OnInstallINF)
		COMMAND_ID_HANDLER_EX(IDC_BTN_PCIIDE, OnEnablePCIIDE)
		COMMAND_ID_HANDLER_EX(IDC_BTN_MSAHCI, OnEnableMSAHCI)
		COMMAND_ID_HANDLER_EX(IDC_BTN_IASTORV, OnEnableIASTORV)
	END_MSG_MAP()

	BOOL OnInitDialog(HWND /*wndFocus*/, LPARAM /*lInitParam*/);
	void OnDestroy();
	void OnCancel(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnInstallINF(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnEnablePCIIDE(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnEnableMSAHCI(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);
	void OnEnableIASTORV(unsigned int /*uNotifyCode*/, int /*nID*/, HWND /*wndCtl*/);

	void CloseDialog(int nVal);

	void displaySATAControllerStatus();
};

extern wchar_t const *APP_TITLE;
