#include "StdAfx.h"
#include "DeviceInfoList.h"

DeviceInfoList::DeviceInfoList(GUID const *class_guid, wchar_t const *enumerator, DWORD flags)
{
	this->devinfo = ::SetupDiGetClassDevs(class_guid, enumerator, NULL, flags);
	if (this->devinfo == INVALID_HANDLE_VALUE) {
		throw MyLib::Win32Exception();
	}
}

DeviceInfoList::~DeviceInfoList(void)
{
	::SetupDiDestroyDeviceInfoList(this->devinfo);
}

HDEVINFO DeviceInfoList::get() const
{
	return this->devinfo;
}
