#pragma once

namespace MyLib {
class FolderDialog :
	public CFolderDialogImpl<FolderDialog>
{
public:
	FolderDialog(std::wstring const &initial_dir_path,
	             HWND hWndParent = NULL,
	             LPCTSTR lpstrTitle = NULL,
	             UINT uFlags = BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE)
		: CFolderDialogImpl<FolderDialog>(hWndParent, lpstrTitle, uFlags)
		, initial_dir_path(initial_dir_path)
	{
	}

	void OnInitialized()
	{
		// ŏɑIԂɂtH_
		this->SetSelection(initial_dir_path.c_str());
	}

	void OnSelChanged(ITEMIDLIST *pidl)
	{
		// u}CRs[^vȂǂłOK{^𖳌ɂ
		TCHAR buf[MAX_PATH];
		this->EnableOK(::SHGetPathFromIDList(pidl, buf));
	}

protected:
	std::wstring initial_dir_path;
};
};
